program Lloret2001;

{   Sunshines Lloret2001

    Lloret 2001, das war der vielleicht beste Urlaub meines Lebens!
    Deshalb hab ich mir gedacht, warum nicht was programmieren, wobei ich immer an
    diese schne Zeit denken kann.
    Da das mein erstes Programm unter OpenGL ist, kam halt nur ein simples
    Partikelsystem und ein sich drehender Wrfel raus.
    Hoffe euch gefllts und ihr knnt was lernen!
    Hinweise:
      Basecode fr Delphi von Peter De Jaegher(Perry.dj@glo.be)
      Originaler Basecode von Jeff Molofee 2000
      Besucht seine Seite : http://nehe.gamedev.net (SUPER OpenGL Tuts)
    Lest auch readme.txt!                                                      }

uses
  Windows,
  Messages,
  OpenGL,
  GLaux;        //Glaux unit

{ The 'glAux' unit can be found at
     http:=//www.delphi-jedi.org/DelphiGraphics/OpenGL/GLAux.zip    }

{$R ico.res}
     
procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;


type
  particle = record
             x, y, z : GLFloat;
             spx, spy, spz : GLFloat;
             grav : GLFloat;
             end;
const
   max = 50;
var
  h_Rc: HGLRC;		            // Permanent Rendering Context
  h_Dc: HDC;                        // Private GDI Device Context
  h_Wnd:HWND;                       // Holds Our Window Handle
  keys: array [0..255] of BOOL;	    // Array Used For The Keyboard Routine
  Active:bool;                      // Window Active Flag
  FullScreen:bool;                  // Fullscreen Flag
  texture : array[0..2] of GLuint;
  p :  array[1..max] of particle;
  bottleheight : GlFloat = 1.5;
  ladd : bool;                      // + Taste
  lminus : bool;                    // - Taste
  rotx : GLFLoat;
  roty : GlFloat;
  speedx : GLFloat = 0.4;
  speedy : GLFloat = 0.6;

  //Wrfel oder Fontne
  lspace : bool;                    // Leertaste gedrckt?
  spray : bool = true;              // spray = true -> Fontne (False -> Wrfel)

function gluBuild2DMipmaps(target: GLenum; components, width, height: GLint; format, atype: GLenum; Data: Pointer): GLint; stdcall; external glu32;


procedure LoadGLTextures;
var
    texture1: PTAUX_RGBImageRec;
    texture2: PTAUX_RGBImageRec;
    texture3: PTAUX_RGBImageRec;
begin
	// Texturen laden
	texture1 := auxDIBImageLoadA('bud3.bmp');
	if (not Assigned(texture1)) then
        Halt(1);

        texture2 := auxDIBImageLoadA('Lloret.bmp');
	if (not Assigned(texture2)) then
        Halt(1);

        texture3 := auxDIBImageLoadA('budlogo.bmp');
	if (not Assigned(texture3)) then
        Halt(1);

	// Texturen generieren
	glGenTextures(3, texture[0]);

	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, texture1^.sizeX, texture1^.sizeY, GL_RGB, GL_UNSIGNED_BYTE, texture1^.data);

        glBindTexture(GL_TEXTURE_2D, texture[1]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, texture2^.sizeX, texture2^.sizeY, GL_RGB, GL_UNSIGNED_BYTE, texture2^.data);

        glBindTexture(GL_TEXTURE_2D, texture[2]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, texture3^.sizeX, texture3^.sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, texture3^.data);
end;


procedure ReSizeGLScene(Width: GLsizei; Height: GLsizei); //Resize And Initialze The GL Window

var
  fWidth, fHeight: GLfloat;

begin
  if (Height=0) then		     // Prevent A Divide By Zero If The Window Is Too Small
     Height:=1;                      // By Making The Height One
  glViewport(0, 0, Width, Height);   // Reset The Current Viewport And Perspective Transformation
  glMatrixMode(GL_PROJECTION);       // Select The Projection Matrix
  glLoadIdentity();                  // Reset The Projection Matrix
  fWidth := width;
  fHeight := height;
  gluPerspective(45.0,fWidth/fHeight,0.1,60.0);// Calculate The Aspect Ratio Of The Window
  glMatrixMode(GL_MODELVIEW);        // Select The Modelview Matrix
  glLoadIdentity                     //Reset The Modelview Matrix
end;



function InitGL:bool;
var
  i : Integer;
begin
  LoadGLTextures();
  glEnable(GL_TEXTURE_2D);
  glDepthFunc(GL_LESS);

  glShadeModel(GL_SMOOTH);			   // Enables Smooth Color Shading
  glClearColor(0.0, 0.0, 0.0, 0.5);		   // Black Background
  glClearDepth(1.0);				   
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);//Realy Nice perspective calculations
    // GlBlendFunc fr Transparenz wichtig!
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);
  GLEnable(GL_BLEND);

  for i := 1 to max do
  begin
     p[i].x := 0.0;
     p[i].y := -10.0;
     p[i].z := 0.0;
     p[i].spx := (Random(19)-10)/(i+70);
     p[i].spy := (Random(5) + 10)/(i+40);
     p[i].grav := 0.002;
  end;
  initGL:=true;
end;



function DrawGLScene():bool; // wichtigeste Funktion : zeichnet alles auf Bildschirm
var
  x,y : GLfloat;
  i : Integer;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();

  glTranslatef(0.0,0.0, -35.0);                  //aus Bildschirm herauszoomen
  // zeichnet Lloret2001-Textur an oberen Bildschrim
  glBindTexture(GL_TEXTURE_2D, texture[1]);
  GlBegin(GL_QUADS);
    glTexCoord2f(0.0,0.0); glVertex3f(-10,5,0);
    glTexCoord2f(1.0,0.0); glVertex3f(10,5,0);
    glTexCoord2f(1.0,1.0); glVertex3f( 10,15,0);
    glTexCoord2f(0.0,1.0); glVertex3f(-10,15,0);
  glEnd;



  IF not spray then  //Wrfel
  BEGIN 
  glDisable(GL_Blend);                          //Transparenz aus!
  glBindTexture(GL_TEXTURE_2D, texture[2]);
  glEnable(GL_DEPTH_TEST);
  GlTranslatef(0.0, -2.5, 0.0);
  glrotatef(rotx,1.0,0.0,0.0);                  // Wrfel rotieren lassen um x-Achse
  glrotatef(roty,0.0,1.0,0.0);                  // Wrfel rotieren lassen um y-Achse

  glBegin(GL_QUADS);   // Wrfel zeichnen
		// Vorderseite
		glNormal3f( 0.0, 0.0, 1.0);
		glTexCoord2f(0.0, 0.0); glVertex3f(-6.0, -6.0,  6.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 6.0, -6.0,  6.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 6.0,  6.0,  6.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-6.0,  6.0,  6.0);
		// Hinterseite
		glNormal3f( 0.0, 0.0,-1.0);
		glTexCoord2f(1.0, 0.0); glVertex3f(-6.0, -6.0, -6.0);
		glTexCoord2f(1.0, 1.0); glVertex3f(-6.0,  6.0, -6.0);
		glTexCoord2f(0.0, 1.0); glVertex3f( 6.0,  6.0, -6.0);
		glTexCoord2f(0.0, 0.0); glVertex3f( 6.0, -6.0, -6.0);
		// Oberseite
		glNormal3f( 0.0, 1.0, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-6.0,  6.0, -6.0);
		glTexCoord2f(0.0, 0.0); glVertex3f(-6.0,  6.0,  6.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 6.0,  6.0,  6.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 6.0,  6.0, -6.0);
		// Unterseite
		glNormal3f( 0.0,-1.0, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f(-6.0, -6.0, -6.0);
		glTexCoord2f(0.0, 1.0); glVertex3f( 6.0, -6.0, -6.0);
		glTexCoord2f(0.0, 0.0); glVertex3f( 6.0, -6.0,  6.0);
		glTexCoord2f(1.0, 0.0); glVertex3f(-6.0, -6.0,  6.0);
		// Rechte Seite
		glNormal3f( 1.0, 0.0, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f( 6.0, -6.0, -6.0);
		glTexCoord2f(1.0, 1.0); glVertex3f( 6.0,  6.0, -6.0);
		glTexCoord2f(0.0, 1.0); glVertex3f( 6.0,  6.0,  6.0);
		glTexCoord2f(0.0, 0.0); glVertex3f( 6.0, -6.0,  6.0);
		// Linke Seite
		glNormal3f(-1.0, 0.0, 0.0);
		glTexCoord2f(0.0, 0.0); glVertex3f(-6.0, -6.0, -6.0);
		glTexCoord2f(1.0, 0.0); glVertex3f(-6.0, -6.0,  6.0);
		glTexCoord2f(1.0, 1.0); glVertex3f(-6.0,  6.0,  6.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(-6.0,  6.0, -6.0);
	glEnd();
 // glrotatef(rotx,1.0,0.0,0.0);
 // glrotatef(roty,0.0,1.0,0.0);
  GlTranslatef(0.0, 2.5, 0.0);
  glDisable(GL_DEPTH_TEST);
  glEnable(GL_Blend);          //Transparenz wieder an

  END
  ELSE             // spray = true -> Fontne
  BEGIN
  glBindTexture(GL_TEXTURE_2D, texture[0]);
  for i := 1 to max do
  begin
    x := P[i].x;
    y := P[i].y;


    glBegin(GL_QUADS);
      glTexCoord2f(0.0,0.0);    glVertex3f(x-bottleheight, y-bottleheight, 0.0);
      glTexCoord2f(1.0,0.0);    glVertex3f(x+bottleheight, y-bottleheight, 0.0);
      glTexCoord2f(1.0,1.0);    glVertex3f(x+bottleheight, y+bottleheight, 0.0);
      glTexCoord2f(0.0,1.0);    glVertex3f(x-bottleheight, y+bottleheight, 0.0);
    glEnd();
    p[i].x := p[i].x + p[i].spx;
    P[i].spy := p[i].spy - p[i].grav;
    p[i].y := p[i].y + p[i].spy;

    //auerhalb des Bildschirms, also wieder an Anfang setzen
    if (p[i].x > 20) or (p[i].x < -20)  or (p[i].y < -20) then
    begin
      p[i].x := 0;
      p[i].y := -13.3;
      p[i].spx := (Random(17)-8)/(i+100);
      p[i].spy := (Random(5) + 11)/(i+40);
      p[i].grav := 0.002;
    end;
  end;

  END;
  
  rotx := rotx + speedx;
  roty := roty + speedy;
  DrawGLScene:=true;            // Everything Went OK
end;



function WndProc(hWnd: HWND;         //Handle For The Window
                 message: UINT;      //Message For This Window
                 wParam: WPARAM;     //Additional Message Information
                 lParam: LPARAM):    //Additional Message Information
                                  LRESULT; stdcall;

begin
  // The WM_SYSCOMMAND Message Is Not In The Case-Loop, Because If It Is, Other Messages
  // Won't Be Handled Anymore(If You Know The Reason, Please Let Me Know...)
  if message=WM_SYSCOMMAND then    //Intercept System Commands
    begin
      case wParam of                         //Check System Calls
        SC_SCREENSAVE,SC_MONITORPOWER:       //Screensaver Trying To Start, Monitor Trying To Enter Powersave?
          begin
            result:=0;                       //Prevent This From Happening
            exit;                            //Exit
          end;
      end;
    end;
  case message of // Tells Windows We Want To Check The Message
    WM_ACTIVATE:
      begin
        if (Hiword(wParam)=0) then  //Check Minimization State
          active:=true              //Program Is Active
        else
          active:=false;            //Program Is No Longer Active
        Result:=0;                  //Return To The Message Loop
      end;
    WM_CLOSE:                       //Did We Get A Close Message
      Begin
        PostQuitMessage(0);         //Send A Quit Message
        result:=0                   //Return To The Message Loop
      end;
    WM_KEYDOWN:                     //Is A Key Being Held Down?
      begin
        keys[wParam] := TRUE;       //If So, Mark It As True
        result:=0;                  //Return To The Message Loop
      end;
    WM_KEYUP:                       //Is A Key Being Released?
      begin
    	keys[wParam] := FALSE;      //If So, Mark It As False
        result:=0;                  //Return To The Message Loop
      end;
    WM_SIZe:                        //Resize The GL Window
      begin
    	ReSizeGLScene(LOWORD(lParam),HIWORD(lParam)); //Loword=Width, Highword=Height
        result:=0;                  //Return To The Message Loop
      end
    else
      //Pass All Unhandled Messages To DefWinProc
      begin
      	Result := DefWindowProc(hWnd, message, wParam, lParam);
      end;
    end;
end;

procedure KillGLWindow; //Properly Kill The Window

begin
  if FullScreen then   //Are We In Fullscreen Mode?
    begin
      ChangeDisplaySettings(devmode(nil^),0); //Switch Back To The Desktop
      showcursor(true);  //Show The Mouse Pointer
    end;
  if h_rc<>0 then       //Is There A Rendering Context?
    begin
      if (not wglMakeCurrent(h_Dc,0)) then   //Are We Able To Release Dc and Rc contexts?
        MessageBox(0,'Release of DC and RC failed.',' Shutdown Error',MB_OK or MB_ICONERROR);
      if (not wglDeleteContext(h_Rc)) then   //Are We Able To Delete The Rc?
        begin
          MessageBox(0,'Release of Rendering Context failed.',' Shutdown Error',MB_OK or MB_ICONERROR);
          h_Rc:=0;                           //Set Rc To Null
        end;
    end;
  if (h_Dc=1) and (releaseDC(h_Wnd,h_Dc)<>0) then   //Are We Able To Release The Dc?
    begin
      MessageBox(0,'Release of Device Context failed.',' Shutdown Error',MB_OK or MB_ICONERROR);
      h_Dc:=0;                           //Set Dc To Null
    end;
  if (h_Wnd<>0) and (not destroywindow(h_Wnd))then   //Are We Able To Destroy The Window?
    begin
      MessageBox(0,'Could not release hWnd.',' Shutdown Error',MB_OK or MB_ICONERROR);
      h_Wnd:=0;                          //Set hWnd To Null
    end
end;





function CreateGlWindow(title:Pchar; width,height,bits:integer;FullScreenflag:bool):boolean stdcall;
var
  Pixelformat: GLuint;           //Holds The Result After Searching For A Match
  wc:TWndclass;                  //Windows Class Structure
  dwExStyle:dword;               //Extended Window Style
  dwStyle:dword;                 //Window Style
  pfd: pixelformatdescriptor;    //Tells Windows How We Want Things To Be
  dmScreenSettings: Devmode;     //Device Mode
  h_Instance:hinst;              // Holds The Instance Of The Application
begin
  h_instance:=getmodulehandle(nil); //Grab An Instance For Our Window
  FullScreen:=FullScreenflag;       //Set The Global Fullscreen Flag
  with wc do
    begin
      style:=CS_HREDRAW or CS_VREDRAW or CS_OWNDC;   //Redraw On Size -- Own DC For Window
      lpfnWndProc:=@WndProc;                         //WndProc Handles The Messages
      cbClsExtra:=0;                                 //No Extra Window Data
      cbWndExtra:=0;                                 //No Extra Window Data
      hInstance:=h_Instance;                         //Set The Instance
      hIcon:=LoadIcon(0,IDI_WINLOGO);                //Load The Default Icon
      hCursor:=LoadCursor(0,IDC_ARROW);              //Load The Arrow Pointer
      hbrBackground:=0;                              //No BackGround Required For OpenGL
      lpszMenuName:=nil;                             //We Don't Want A Menu
      lpszClassName:='OpenGl';                       //Set The CLass Name
    end;
  if  RegisterClass(wc)=0 then                       //Attempt To Register The Window Class
    begin
      MessageBox(0,'Failed To Register The Window Class.','Error',MB_OK or MB_ICONERROR);
      CreateGLwindow:=false;                         //Return False
      exit;                                          //Exit
    end;
  if FullScreen then                                 //Attempt Fullscreen Mode
    begin
      ZeroMemory( @dmScreenSettings, sizeof(dmScreenSettings) );  //Makes Sure Memory's Available
      with dmScreensettings do
        begin
          dmSize := sizeof(dmScreenSettings);         //Size Of The Devmode Structure
          dmPelsWidth  := width;	              //Selected Screen Width
	  dmPelsHeight := height;                     //Selected Screen Height
          dmBitsPerPel := bits;                       //Selected Bits Per Pixel
          dmFields     := DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT;
        end;
      //Try To Set The Selected Mode And Get Results. CDS_FullScreen Gets Rid Of The Start Bar
      if (ChangeDisplaySettings(dmScreenSettings, CDS_FullScreen))<>DISP_CHANGE_SUCCESSFUL THEN
        Begin
          if MessageBox(0,'This FullScreen Mode Is Not Supported. Use Windowed Mode Instead?'
                                             ,'NeHe GL',MB_YESNO or MB_ICONEXCLAMATION)= IDYES then
                FullScreen:=false   //Select The Windowed Mode
          else
            begin
              //Popup A Message Box Letting The User Know The Program Is Closing
              MessageBox(0,'Program Will Now Close.','Error',MB_OK or MB_ICONERROR);
              CreateGLWindow:=false;    //Return False
            end;
          end;
    end;
  if FullScreen then  //Check If We're Still In Fullscreen Mode
    begin
      dwExStyle:=WS_EX_APPWINDOW;  //Extended Window Style
      dwStyle:=WS_popup or WS_CLIPSIBLINGS or WS_CLIPCHILDREN; //Window Style
      Showcursor(false);           //Hide Mouse Pointer
    end
  else
    begin
      dwExStyle:=WS_EX_APPWINDOW or WS_EX_WINDOWEDGE;   //Extended Window Style
      dwStyle:=WS_OVERLAPPEDWINDOW or WS_CLIPSIBLINGS or WS_CLIPCHILDREN; //Windows Style
    end;
  //Create The Window
  H_wnd:=CreateWindowEx(dwExStyle,                   //Extende Style For The Window
                               'OpenGl',             //Class Name
                               Title,                //Window Title
                               dwStyle,              //Window Style
                               0,0,                  //Window Position
                               width,height,         //Selected Width and Height
                               0,                    //No Parent Window
                               0,                    //No Menu
                               hinstance,            //Instance
                               nil);                 //Don't Pass Anything To WM_CREATE
  if h_Wnd=0 then              //If The Window Creation Failed
    begin
      KillGlWindow();          //Reset The Display
      MessageBox(0,'Window creation error.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;   //Return False
      exit;
    end;
  with pfd do    //Tells Windows How We Want Things To Be
    begin
      nSize:= SizeOf( PIXELFORMATDESCRIPTOR ); // Size Of This Pixel Format Descriptor
      nVersion:= 1;                            // Version Number (?)
      dwFlags:= PFD_DRAW_TO_WINDOW             // Format Must Support Window
        or PFD_SUPPORT_OPENGL                  // Format Must Support OpenGL
        or PFD_DOUBLEBUFFER;                   // Must Support Double Buffering
      iPixelType:= PFD_TYPE_RGBA;              // Request An RGBA Format
      cColorBits:= bits;                       // Select Our Color Depth
      cRedBits:= 0;                            // Color Bits Ignored
      cRedShift:= 0;
      cGreenBits:= 0;
      cBlueBits:= 0;
      cBlueShift:= 0;
      cAlphaBits:= 0;                          // No Alpha Buffer
      cAlphaShift:= 0;                         // Shift Bit Ignored
      cAccumBits:= 0;                          // No Accumulation Buffer
      cAccumRedBits:= 0;                       // Accumulation Bits Ignored
      cAccumGreenBits:= 0;
      cAccumBlueBits:= 0;
      cAccumAlphaBits:= 0;
      cDepthBits:= 16;                         // 16Bit Z-Buffer (Depth Buffer)
      cStencilBits:= 0;                        // No Stencil Buffer
      cAuxBuffers:= 0;                         // No Auxiliary Buffer
      iLayerType:= PFD_MAIN_PLANE;             // Main Drawing Layer
      bReserved:= 0;                           // Reserved
      dwLayerMask:= 0;                         // Layer Masks Ignored
      dwVisibleMask:= 0;
      dwDamageMask:= 0;
    end;
  h_Dc := GetDC(h_Wnd);                        // Try Getting A Device Context
  if h_Dc=0 then                               // Did We Get Device Context For The Window?
    begin
      KillGLWindow();                          //Reset The Display
      MessageBox(0,'Cant''t create a GL device context.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;                   //Return False
      exit;
    end;
  PixelFormat := ChoosePixelFormat(h_Dc, @pfd);// Finds The Closest Match To The Pixel Format We Set Above
  if (PixelFormat=0) then                      //Did We Find A Matching Pixelformat?
    begin
      KillGLWindow();                          //Reset The Display
      MessageBox(0,'Cant''t Find A Suitable PixelFormat.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;                   //Return False
      exit;
    end;
  if (not SetPixelFormat(h_Dc,PixelFormat,@pfd)) then  //Are We Able To Set The Pixelformat?
    begin
      KillGLWindow();                          //Reset The Display
      MessageBox(0,'Cant''t set PixelFormat.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;                   //Return False
      exit;
    end;
  h_Rc := wglCreateContext(h_Dc);              //Are We Able To Get A Rendering Context?
  if (h_Rc=0) then
    begin
      KillGLWindow();                          //Reset The Display
      MessageBox(0,'Cant''t create a GL rendering context.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;                   //Return False
      exit;
    end;
  if (not wglMakeCurrent(h_Dc, h_Rc)) then     //Are We Able To Activate The Rendering Context?
    begin
      KillGLWindow();                          //Reset The Display
      MessageBox(0,'Cant''t activate the GL rendering context.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;                   //Return False
      exit;
    end;
  ShowWindow(h_Wnd,SW_SHOW);       //Show The Window
  SetForegroundWindow(h_Wnd);      //Slightly Higher Priority
  SetFOcus(h_Wnd);                 //Set Keyboard Focus To The Window
  ReSizeGLScene(width,height);     //Set Up Our Perspective Gl Screen
  if (not InitGl()) then           //Can we Initialize The Newley Created GL Window
    begin
      KillGLWindow();              //Reset The Display
      MessageBox(0,'initialization failed.','Error',MB_OK or MB_ICONEXCLAMATION);
      CreateGLWindow:=false;       //Return False
      exit;
    end;

  CreateGLWindow:=true;            //Succes
end;






function WinMain(hInstance: HINST;          //Instance
		 hPrevInstance: HINST;      //Previous Instance
		 lpCmdLine: PChar;          //Command Line Parameters
		 nCmdShow: integer):        //Window Show State
                                    integer; stdcall;

var
  msg: TMsg;      // Windows Message Structure
  done: Bool;     // Variable To Exit The Loop

begin
  done:=false;
  FullScreen:=true;      //Fullscreen Mode
  if not CreateGLWindow('Sunshines Lloret2001',640,480,16,FullScreen) then //Could We Create The OpenGl Window?
    begin
      Result := 0;    //Quit If The Window Wasn't Created
      exit;
    end;
  while not done do   //Loop That Keeps The Program Running
    begin
      if (PeekMessage(msg, 0, 0, 0, PM_REMOVE)) then  //Is There A Message Running
        begin
          if msg.message=WM_QUIT then                 //Have We Received A Quit Message?
            done:=true                                //If So, Done=True
          else
            begin
	      TranslateMessage(msg);                  //Translate The Message
	      DispatchMessage(msg);                   //Dispatch The Message
	    end;
        end
      else
        begin
          //Draw The GL Scene. Watch For ESC Key Aned Quit Messages from DrawGLScene()
          if (active and not(DrawGLScene()) or keys[VK_ESCAPE]) then
            done:=true                      //ESC PRessed Or DrawGLScene Signalle A Quit
          else
            SwapBuffers(h_Dc);              //Not Time TO Quit Yet, Update The Screen

        if (keys[VK_ADD] and not ladd) then
            begin
	      ladd:=TRUE;
	      bottleheight := bottleheight + 0.1;   // Flaschen vergrern
            end;
      if (not keys[VK_ADD]) then ladd:=FALSE;

      if (keys[VK_Subtract] and not lminus) then
            begin
	      lminus:=TRUE;
	      bottleheight := bottleheight - 0.1;   // Flaschen verkleinern
            end;
      if (not keys[VK_Subtract]) then lminus:=FALSE;

      if (keys[VK_SPACE] and not lspace) then
            begin
	      lspace:=TRUE;
	      spray := not spray;
            end;
      if (not keys[VK_Space]) then lspace:=FALSE;

      if (keys[VK_UP]) then
      	speedx:=speedx-0.01;
      if (keys[VK_DOWN]) then
			speedx:=speedx+0.01;
      if (keys[VK_RIGHT]) then
      			speedy:=speedy+0.01;
      if (keys[VK_LEFT]) then
			speedy:=speedy-0.01;

        end;
    end;
  killGLwindow();                           //Shutdown
  result:=msg.wParam;
end;

begin
  active:=true;                             //The Active Variable Is Set To True By Default
  WinMain( hInstance, hPrevInst, CmdLine, CmdShow );   //This Starts the program
end.

